



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linq二 LinqToSql</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linq二 LinqToSql</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-27 18:26:49 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>虽然微软已经停止更新了LinqToSql，但是目前的已完全满足目前的需求.</p>
<p>第一步：添加LinqToSql</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/504910/201312/22193810-6d44f9ae65e44d3ebf061c135934436e.png" /></p>
<p>第二步：将其关联的Sqlserver数据库</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/504910/201312/22193923-37253e82c24f412394fb9e6131da453b.jpg" /></p>
<p>第三步：数据库已变成实体类</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/504910/201312/22194122-cab4af5546904dcfb00f6afb78f8b0ca.png" /></p>
<p>第四步：可以对数据库进行增删改查操作</p>
<div>
<pre class="prettyprint linenums">   static void Main(string[] args)<br />
        {<br />
            DataClassesDataContext dataContext = new DataClassesDataContext();

            //生成分类实体类<br />
            Category category1 = new Category()<br />
            {<br />
                Name = "国际要闻"<br />
            };<br />
            dataContext.Category.InsertOnSubmit(category1);<br />
            dataContext.SubmitChanges();<br />
        }</pre>
</div>
<p>这样就新增成功了</p>
<p><strong>DataClassesDataContext&nbsp;</strong> 这个相当于EF中的DBContext，数据库所有对象都在里面了</p>
<p><strong>DataClassesDataContext的属性Category</strong>就是映射数据表的一个集合属性</p>
<p>Category category1 = new Category()&nbsp;&nbsp; 就相当于表的实体类，属性映射到对应字段</p>
<p><strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Insert操作<br /></strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Insert用于向数据库添加记录。一般情况下，使用&ldquo;DataContext.表映射集合.InsertOnSubmit(实体类)&rdquo;的方式就可以完成Insert操作。不过这里要注意一点，由于Linq to Sql使用了&ldquo;Unit of Work&rdquo;模式，所以，对数据库的操作不会立即提交到数据库，而要调用DataContext的SubmitChanges方法，所有改动才会被提交到数据库。</p>
<p><strong>Delete操作<br /></strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Delete操作用于从数据库中删除记录。表映射集合的DeleteOnSubmit方法可以实现这个操作。这个方法需要一个参数，就是要删除的实体类，这里不能直接传个ID去删除，要首先通过ID找到相应实体类，传给DeleteOnSubmit再删除。当然最后不要忘了SubmitChanges。</p>
<p><strong>Update操作<br /></strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Update操作用于更新数据库中某已存在记录的信息。在Linq to Sql中，Update操作就是首先加载相应的实体类，修改其相应字段后，SubmitChanges就可以了。</p>
<p><strong>Select操作</strong></p>
<p><strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; dataContext.Category</strong>是一个linq.Data.Table&lt;T&gt;的一个泛型集合，所有我们可以使用Linq进行查询</p>
<div>
<pre class="prettyprint linenums"> var s = from b in dataContext.Category<br />
                    where b.ID ==<br />
                    orderby b.ID<br />
                    select b.Name;</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq12109g.html">Swift3中函数的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7l1de8.html">qt qml qchart 图表组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/495jo66q.html">UnitTesting中的ClassInitialize，ClassCleanup，TestInitialize，TestClearup</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq14gn6q.html">Yii2 return redirect&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93kl3rq.html">AngularJs angular&period;uppercase、angular&period;lowercase、angular&period;fromJson、angular&period;toJson</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnr4ng9.html">nrf51822-使用16位自定义UUID</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1okd19.html">poj1845 数论</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m7joxq.html">使用XShell工具密钥认证登录Linux系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnrv7pq.html">Zabbix探索：LDAP的认证方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j03p1lq.html">Java组合与继承生成的类中构造函数的执行顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mp47j8.html">angular&period;js封装的文件上传指令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mery3rq.html">Fibonacci Numbers</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yl2xw8.html">关于margin-top的一些特别问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz66048.html">ASP&period;NET MVC5  Forms登陆&plus;权限控制（控制到Action&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj4v269.html">Python协程的引入与原理分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eynyem9.html">Python档案袋（列表、元组、字典、集合 &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zodwy3q.html">TableML-GUI篇&lpar;C&num; 编译&sol;解析 Excel&sol;CSV工具&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj7rjx8.html">Linux查询进程和结束进程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvny0j8.html">create table 使用select查询语句创建表的方法分享</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd542z9.html">bat获取文件夹里面所有文件夹的名称方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/wq1x3oz8.html">一、Docker之旅</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j73kg9.html">YOU KNOW NOTHING &comma; SNOW</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvw47j9.html">《R语言实战》读书笔记-- 第六章 基本图形</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxgp5j9.html">css 打字动画</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxg1g09.html">。linux中swap分区</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zng118.html">php &colon; 匿名函数&lpar;闭包&rpar; &lbrack;一&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8elewxq.html">cpp blog上面看到一哥们写的 下拉列表</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j40oe9.html">zoj3494BCD Code&lpar;ac自动机&plus;数位dp&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd4povq.html">windows&plus;linux开发环境 解决laravel blade模板缓存问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7yooxq.html">kafka原理存储</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
